# Scenarios.py -- Pamhyr
# Copyright (C) 2024-2025  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

from functools import reduce

from tools import logger_exception

from Model.Tools.PamhyrDict import PamhyrModelDict
from Model.Scenario import Scenario


class Scenarios(PamhyrModelDict):
    _sub_classes = [
        Scenario,
    ]

    @classmethod
    def _db_load(cls, execute, data=None):
        new = cls(status=data["status"])

        new._dict = Scenario._db_load(
            execute,
            data=data
        )

        return new

    def _db_save(self, execute, data=None):
        ok = True
        if data is None:
            data = {}

        scenarios = self._dict
        for sid in scenarios:
            ok &= scenarios[sid]._db_save(execute, data)

        return ok

    def get(self, key):
        if key in self._dict:
            return self._dict[key]

        return None

    def new(self, parent):
        new = Scenario(parent=parent)
        self.set(new._id, new)
        return new

    def __len__(self):
        return len(self.lst)

    @property
    def lst(self):
        return list(
            map(
                lambda k: self.get(k),
                self._dict
            )
        )

    def delete(self, key):
        if key not in self._dict:
            return

        self._dict[key].set_as_deleted()
        self._status.modified()

    def is_leaf(self, scenario):
        return not reduce(
            lambda acc, s: (
                acc or (not s.is_deleted() and s.parent is scenario)
            ),
            self._dict.values(),
            False
        )
